/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.velocitycore.commands;

import com.velocitypowered.api.proxy.Player;
import de.steamwar.command.SWCommand;
import de.steamwar.linkage.Linked;
import de.steamwar.messages.Chatter;
import de.steamwar.messages.ChatterGroup;
import de.steamwar.messages.PlayerChatter;
import de.steamwar.sql.IgnoreSystem;
import de.steamwar.velocitycore.VelocityCore;
import de.steamwar.velocitycore.listeners.ChatListener;

import static de.steamwar.persistent.Storage.lastChats;

@Linked
public class MsgCommand extends SWCommand {

    public MsgCommand() {
        super("msg", "w", "tell");
    }

    @Register(description = "MSG_USAGE")
    public void genericCommand(PlayerChatter sender, @ErrorMessage(value = "MSG_OFFLINE") Player target, @ErrorMessage(value = "MSG_USAGE", allowEAs = false) String... message) {
        msg(sender, target, message);
    }

    public static void msg(PlayerChatter sender, Player target, String[] args) {
        if (target == null || VelocityCore.getProxy().getPlayer(target.getUniqueId()).orElse(null) == null) {
            sender.system("MSG_OFFLINE");
            return;
        }

        if (IgnoreSystem.isIgnored(target.getUniqueId(), sender.user().getUUID())) {
            sender.system("MSG_IGNORED");
            return;
        }

        Chatter receiver = Chatter.of(target);
        ChatListener.sendChat(sender, new ChatterGroup(sender, receiver), "CHAT_MSG", receiver, String.join(" ", args));
        lastChats.put(sender.getPlayer(), target);
        lastChats.put(target, sender.getPlayer());
    }

    public static void remove(Player player) {
        lastChats.remove(player);
    }
}
